﻿Public Class Form1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

    End Sub

    Private Sub PictureBox5_Click(sender As Object, e As EventArgs) Handles PictureBox5.Click
        ' Воспроизведение 
        If AxWindowsMediaPlayer1.URL = ListBox1.SelectedItem Then
            AxWindowsMediaPlayer1.Ctlcontrols.play()
            Timer1.Start()
        End If
        ' Воспроизведение сохраненного плейлиста
        If AxWindowsMediaPlayer1.URL = OpenFileDialog1.FileName Then
            AxWindowsMediaPlayer1.Ctlcontrols.play()
            Timer1.Start()
        End If
    End Sub

    Private Sub PictureBox1_Click(sender As Object, e As EventArgs) Handles PictureBox1.Click
        ' Пауза 
        AxWindowsMediaPlayer1.Ctlcontrols.pause()
    End Sub

    Private Sub PictureBox2_Click(sender As Object, e As EventArgs) Handles PictureBox2.Click
        ' Стоп 
        AxWindowsMediaPlayer1.Ctlcontrols.stop()
        ProgressBar1.Value = ProgressBar1.Minimum
        Timer1.Stop()
        Timer2.Stop()
    End Sub

    Private Sub PictureBox3_Click(sender As Object, e As EventArgs) Handles PictureBox3.Click
        ' Кнопка вперед 
        AxWindowsMediaPlayer1.Ctlcontrols.stop()
        ProgressBar1.Value = ProgressBar1.Minimum
        AxWindowsMediaPlayer1.URL = ""
        ListBox1.SelectedIndex = ListBox1.SelectedIndex - 1
        AxWindowsMediaPlayer1.URL = ListBox1.SelectedItem
        Timer2.Stop()
    End Sub

    Private Sub PictureBox4_Click(sender As Object, e As EventArgs) Handles PictureBox4.Click
        ' Кнопка назад 
        AxWindowsMediaPlayer1.Ctlcontrols.stop()
        ProgressBar1.Value = ProgressBar1.Minimum
        Timer2.Stop()
    End Sub

    Private Sub AxWindowsMediaPlayer1_Enter(sender As Object, e As EventArgs) Handles AxWindowsMediaPlayer1.Enter

    End Sub

    Private Sub ListBox1_DragDrop(sender As Object, e As DragEventArgs) Handles ListBox1.DragDrop
        ' Перетащить файлы мр3 с компьютора на плейлист 
        Dim Files As String() = CType(e.Data.GetData(DataFormats.FileDrop), String())
        For Each FileName As String In Files
            ListBox1.Items.Add(FileName)
        Next
    End Sub

    Private Sub ListBox1_DragEnter(sender As Object, e As DragEventArgs) Handles ListBox1.DragEnter
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        End If
    End Sub

    Private Sub ListBox1_MouseDoubleClick(sender As Object, e As MouseEventArgs) Handles ListBox1.MouseDoubleClick
        ' Запуск плеера двойным щелчком в окне плейлиста
        Dim start1 As Integer = 0
        If start1 = 1 Then
            If AxWindowsMediaPlayer1.URL = ListBox1.Text Then
                AxWindowsMediaPlayer1.Ctlcontrols.play()

            End If
        End If
        If start1 = 0 Then
            AxWindowsMediaPlayer1.URL = ListBox1.Text
            start1 = +1
            AxWindowsMediaPlayer1.Ctlcontrols.play()
            Timer1.Start()
        End If
    End Sub

    Private Sub ListBox1_MouseDown(sender As Object, e As MouseEventArgs) Handles ListBox1.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Right Then
            ListBox1.SelectedIndex = Fix(e.Y / ListBox1.ItemHeight)
        End If
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ListBox1.SelectedIndexChanged

    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        ' Длительность песни
        Try
            Label2.Text = AxWindowsMediaPlayer1.Ctlcontrols().currentItem.durationString
        Catch ex As Exception
            Timer1.Start()
        End Try

        'Скорость воспроизведения
        Try
            Label3.Text = AxWindowsMediaPlayer1.currentMedia.getItemInfo("Bitrate") / 1000 & " кбит/с"
        Catch ex As Exception
        End Try

        Try
            ProgressBar1.Maximum = AxWindowsMediaPlayer1.currentMedia.duration
            ProgressBar1.Value = AxWindowsMediaPlayer1.Ctlcontrols.currentPosition
        Catch ex As Exception

        End Try
        ' Код перехода на следующую строку плейлиста
        Dim itemno As Integer
        itemno = ListBox1.SelectedIndex
        Try
            If AxWindowsMediaPlayer1.playState = WMPLib.WMPPlayState.wmppsStopped Then
                Me.ListBox1.SelectedIndex = itemno + 1
                AxWindowsMediaPlayer1.URL = ListBox1.SelectedItem
                AxWindowsMediaPlayer1.Ctlcontrols.play()
                Timer1.Start()
            Else
                itemno = 0
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub Timer2_Tick(sender As Object, e As EventArgs) Handles Timer2.Tick
        ' Код перехода вперёд и назад
        Dim itemno As Integer
        itemno = ListBox1.SelectedIndex
        Try
            If AxWindowsMediaPlayer1.playState = WMPLib.WMPPlayState.wmppsStopped Then
                ListBox1.SelectedIndex = itemno + 1
                AxWindowsMediaPlayer1.URL = ListBox1.SelectedItem
                AxWindowsMediaPlayer1.Ctlcontrols.play()
                Timer2.Start()
            Else
                itemno = 0
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub ProgressBar1_Click(sender As Object, e As EventArgs) Handles ProgressBar1.Click

    End Sub
    Private Sub ProgressBar1_MouseClick(sender As Object, e As MouseEventArgs) Handles ProgressBar1.MouseClick
        ' Щелчком мыши продвигаем индекатор 
        Dim Faktor As Double = (AxWindowsMediaPlayer1.currentMedia.duration / ProgressBar1.Width)
        AxWindowsMediaPlayer1.Ctlcontrols.currentPosition = (e.X * Faktor)
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        ' Установка баланса по центру
        TrackBar2.Value = 50
        Me.AxWindowsMediaPlayer1.settings.balance = 50
        Me.Label1.Text = Math.Round(TrackBar2.Value / (TrackBar2.Maximum - TrackBar2.Minimum) * 100, 1) & "%"
    End Sub

    Private Sub TrackBar1_Scroll(sender As Object, e As EventArgs) Handles TrackBar1.Scroll
        ' установка уровня звука
        If AxWindowsMediaPlayer1 Is Nothing = False Then
            Me.AxWindowsMediaPlayer1.settings.volume = TrackBar1.Value
        End If
    End Sub

    Private Sub TrackBar2_Scroll(sender As Object, e As EventArgs) Handles TrackBar2.Scroll
        ' установка баланса
        If AxWindowsMediaPlayer1 Is Nothing = False Then
            Me.AxWindowsMediaPlayer1.settings.balance = TrackBar2.Value
        End If
        Me.Label1.Text = Math.Round(TrackBar2.Value / (TrackBar2.Maximum - TrackBar2.Minimum) * 100, 1) & "%"
    End Sub

    Private Sub Label1_Click(sender As Object, e As EventArgs) Handles Label1.Click

    End Sub

    Private Sub Label2_Click(sender As Object, e As EventArgs) Handles Label2.Click

    End Sub

    Private Sub Label3_Click(sender As Object, e As EventArgs) Handles Label3.Click

    End Sub

    Private Sub NotifyIcon1_MouseDoubleClick(sender As Object, e As MouseEventArgs) Handles NotifyIcon1.MouseDoubleClick
        Me.Show() ' Двойным щелчком в трее открываем плеер
        NotifyIcon1.Visible = False
    End Sub

    Private Sub FolderBrowserDialog1_HelpRequest(sender As Object, e As EventArgs)

    End Sub

    Private Sub ОткрытьПапкуToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ОткрытьПапкуToolStripMenuItem.Click
        ListBox1.Items.Clear() ' Закрываем предыдущий плейлист
        Dim FoldD As New FolderBrowserDialog
        If FoldD.ShowDialog = Windows.Forms.DialogResult.OK Then
            ListBox1.Items.AddRange(System.IO.Directory.GetFiles(FoldD.SelectedPath, "*"))
        End If
    End Sub

    Private Sub ОткрытьФайлToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ОткрытьФайлToolStripMenuItem.Click
        ListBox1.Items.Clear() ' Закрываем предыдущий плейлист
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            AxWindowsMediaPlayer1.URL = OpenFileDialog1.FileName
            ListBox1.Items.Add(OpenFileDialog1.SafeFileName)
        End If
    End Sub

    Private Sub ОткрытьПлейлистToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ОткрытьПлейлистToolStripMenuItem.Click
        ListBox1.Items.Clear() ' Закрываем предыдущий плейлист
        If My.Computer.FileSystem.FileExists(Application.StartupPath & "\playlist.txt") Then
            Dim reader As New IO.StreamReader(Application.StartupPath & "\playlist.txt")
            Try
                Do
                    ListBox1.Items.Add(reader.ReadLine)

                Loop
            Catch ex As Exception
                reader.Close()
                ListBox1.SelectedIndex = 0
                If My.Settings.AutoPlay = True Then
                    AxWindowsMediaPlayer1.URL = ListBox1.SelectedItem
                    Timer1.Start()
                    My.Settings.Repeat = True
                End If
            End Try
        End If
    End Sub

    Private Sub ОчиститьПлейлистToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ОчиститьПлейлистToolStripMenuItem.Click
        ' Очистка плейлиста
        ListBox1.Items.Clear()
        ProgressBar1.Value = ProgressBar1.Minimum
        Timer1.Stop()
    End Sub

    Private Sub СохранитьПлейлистToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles СохранитьПлейлистToolStripMenuItem.Click
        Dim count As Integer = -1
        Dim writer As New IO.StreamWriter(Application.StartupPath & "\playlist.txt")
        Dim current As Integer = ListBox1.SelectedIndex
        Try
            Do Until count = ListBox1.Items.Count
                ListBox1.SelectedIndex = count + 1
                writer.WriteLine(ListBox1.SelectedItem)
                count = count + 1
            Loop
        Catch ex As Exception
            writer.Close()
            ListBox1.SelectedIndex = current
            MsgBox("Плейлист Сохранен")
        End Try
    End Sub

    Private Sub OpenFileDialog1_FileOk(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles OpenFileDialog1.FileOk

    End Sub

    Private Sub ТрейToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ТрейToolStripMenuItem.Click
        ' Убираем плеер в трей
        NotifyIcon1.Visible = True
        Me.Hide()
    End Sub
End Class
